package net.jakewilliamson.sentry;

import android.content.Context;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.ListView;
import android.widget.TextView;

import java.text.DateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

public class History extends AppCompatActivity
{
    private ListView view;

    private SharedPreferences pref;

    public static void saveData(String hint, String value, String ip, String status, Context context)
    {
        String currentDateTime = DateFormat.getDateTimeInstance().format(new Date());

        final String PREF_NAME = context.getString(R.string.app_name) + "_history_pref";
        SharedPreferences pref = context.getSharedPreferences(PREF_NAME, Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = pref.edit();

        String sb = hint + " - " + value + " heading to " + ip + " - " + status;

        editor.putString(currentDateTime, sb);

        editor.apply();
    }

    protected void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.history);
        String PREF_NAME = getString(R.string.app_name) + "_history_pref";
        pref = getSharedPreferences(PREF_NAME, Context.MODE_PRIVATE);
        view = findViewById(R.id.listView);

        loadData();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu)
    {
        getMenuInflater().inflate(R.menu.history_clear, menu);
        return true;
    }

    private void loadData()
    {
        HashMap kvs = (HashMap) pref.getAll();

        if (0 == kvs.size())
        {
            TextView tv = findViewById(R.id.noHistory);
            tv.setVisibility(View.VISIBLE);
            view.setEmptyView(tv);
        } else
        {
            TextView tv = findViewById(R.id.noHistory);
            tv.setVisibility(View.INVISIBLE);
        }

        List<String> titles = new ArrayList<>();
        List<String> infos = new ArrayList<>();

        for (Object key : kvs.keySet())
        {
            titles.add(String.valueOf(key));
            infos.add(String.valueOf(kvs.get(key)));
        }

        Collections.reverse(titles);
        Collections.reverse(infos);

        String[] titleArray = titles.toArray(new String[0]);
        String[] infoArray = infos.toArray(new String[0]);

        HistoryListAdapter adapter = new HistoryListAdapter(this, titleArray, infoArray);
        view.setAdapter(adapter);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item)
    {
        switch (item.getItemId())
        {
            case R.id.clear_history:
                SharedPreferences.Editor editor = pref.edit();
                editor.clear();
                editor.apply();
                loadData();

                return true;

            default:
                return super.onOptionsItemSelected(item);
        }
    }
}
