package net.jakewilliamson.sentry;

import android.app.Activity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

/**
 * Created by Jake Williamson on 10/04/2018.
 */

class HistoryListAdapter extends ArrayAdapter
{
    private final Activity context;

    private final String[] titleArray;

    private final String[] infoArray;

    HistoryListAdapter(Activity context, String[] titleArray, String[] infoArray)
    {
        super(context, R.layout.listview_row, titleArray);

        this.context = context;
        this.titleArray = titleArray;
        this.infoArray = infoArray;
    }

    public View getView(int position, View view, ViewGroup parent)
    {
        LayoutInflater inflater = context.getLayoutInflater();
        View rowView = inflater.inflate(R.layout.listview_row, null, true);

        TextView nameTextField = rowView.findViewById(R.id.nameTextViewID);
        TextView infoTextField = rowView.findViewById(R.id.infoTextViewID);

        nameTextField.setText(titleArray[position]);
        infoTextField.setText(infoArray[position]);

        return rowView;
    }
}
