package net.jakewilliamson.sentry;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.support.v7.app.AppCompatActivity;
import android.widget.TextView;

public class Loading extends AppCompatActivity
{
    private Context context;
    private TextView tv;
    Long startTime;
    private final Runnable goHome = new Runnable()
    {
        @Override
        public void run()
        {
            Intent i = new Intent(context, Sentry.class);
            i.putExtra("loadTime", startTime);
            startActivity(i);
        }
    };
    private final Runnable getData = new Runnable()
    {
        @Override
        public void run()
        {
            Util.getDataState(context);
            goHome.run();
        }
    };
    private final Runnable getWifi = new Runnable()
    {
        @Override
        public void run()
        {
            Util.getWifiState(context);
            tv.setText(R.string.getting_network_state);
            Handler h = new Handler();
            h.post(getData);
        }
    };
    private final Runnable getApps = new Runnable()
    {
        @Override
        public void run()
        {
            Util.getInstalledApps(false, context);
            tv.setText(R.string.getting_wifi_state);
            Handler h = new Handler();
            h.postDelayed(getWifi, 500);
        }
    };

    @Override
    protected void onCreate(Bundle savedInstanceState)
    {
        startTime = System.nanoTime();
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_loading);
        context = this;
        tv = findViewById(R.id.textView);

        tv.setText(R.string.getting_apps);
        Handler h = new Handler();
        h.postDelayed(getApps, 500);
    }
}
